music = {}

customMusic = {}
function music:load()
	self:loadMusic("music")

	if #customMusic > 0 then
		self:shuffleSongs()
		self.song = customMusic[love.math.random(#customMusic)]
	else
		print("Failed to load custom music!")
	end
end

function music:loadMusic(path)
	local items = love.filesystem.getDirectoryItems(path)

	for k = 1, #items do
		if love.filesystem.isDirectory(path .. items[k]) then
			self:loadMusic(path .. "/" .. items[k])
		else

			if items[k]:sub(-4) == ".ogg" or items[k]:sub(-4) == ".mp3" or items[k]:sub(-4) == ".wav" then
				debugLoadTime(path .. "/" .. items[k])

				table.insert(customMusic, love.audio.newSource(path .. "/" .. items[k], "stream"))
			end
		end
	end
end

function music:shuffleSongs()
	local oldSongs = {} 

	while (#oldSongs ~= #customMusic) do
		local rand = love.math.random(#customMusic)

		if not oldSongs[rand] then
			table.insert(oldSongs, customMusic[rand])
		end
	end

	customMusic = oldSongs
end

function music:play()
	if not customMusicBool then
		return
	end

	self.newsong = customMusic[love.math.random(#customMusic)]
	while self.song == self.newsong do
		self.newsong = customMusic[love.math.random(#customMusic)]
		if self.newsong ~= self.song then
			self.song = self.newsong
			break
		end
	end 

	stopMusic()

	self.song:stop()
	self.song:rewind()
	self.song:play()
end

function music:update(dt)
	if self.song and self.song:isStopped() then
		self:play()
	else
		return
	end
end

function music:stop()
	self.song:stop()
	self.song:rewind()

	checkAudio()
end

music:load()