--[[
	16:24 PM - TurtleP: I'm thinking that it creates an electric forcefield around everyone
	16:24 PM - TurtleP: but anything that touches one is fizzled (including powerups that are dropped)
	16:28 PM - Polybius: thats a good idea
	16:29 PM - Polybius: its fair.
	16:29 PM - Polybius: if one gets hit by an enemy the energy dissipates
	16:29 PM - Polybius: and you can pick up a power up again?
	16:29 PM - Polybius: its kinda like a take a free hit thing?
	16:29 PM - TurtleP: good idea
--]]

local ability = {}

function ability:init(parent)
	objects.plasmashield = {}
	self.plasmaparticles = {}

	self.start = false --clearly 
end

function ability:update(dt)
	if not self.start then
		for k = 1, players do
			table.insert(objects["plasmashield"], newShield(objects["turtle"][k]))
			table.insert(self.plasmaparticles, {timer = math.random()*1, maxtimer = 1})
		end
		self.start = true
	end
	
	for i, v in ipairs(self.plasmaparticles) do
		v.timer = v.timer + dt
		if v.timer >= v.maxtimer then
			v.timer = v.timer - v.maxtimer
		end
	end
end

function ability:draw()
	for i, v in ipairs(objects["plasmashield"]) do
		
	end
end

function newShield(turtle)
	local shield = {}

	shield.parent = turtle
	shield.sinTimer = 0
	shield.sinValue = 0

	shield.x = turtle.x
	shield.y = turtle.y
	shield.width = 40
	shield.height = 40

	function shield:onCollide(name, data)
		if data.emancipateCheck then
			playsound("evaporate")
				
			table.insert(fizzles, fizzle:new(data))

			data.kill = true

			if name == "enemies" then
				self.kill = true
			end
		end
	end

	function shield:update(dt)
		self.x, self.y = (self.parent.x + self.parent.width / 2) - self.width / 2, (self.parent.y + self.parent.height/ 2) - 40 / 2

		if self.sinTimer - dt < math.pi then
			self.sinTimer = self.sinTimer + dt 
		else
			self.sinTimer = 0
		end

		self.sinValue = math.sin(self.sinTimer)
	end

	function shield:draw()
		love.graphics.setColor(75, 153, 230, 255 * self.sinValue)
		love.graphics.rectangle("fill", self.x * scale, self.y * scale, self.width * scale, self.height * scale)
	end

	return shield
end

return ability